import { requireNativeComponent, ViewStyle, NativeModules } from 'react-native';
const { CollectorManager } = NativeModules;

export type VGSEnvironment = 'sandbox' | 'live';

type VGSCollectInputProps = {
  config: {
    collectorName: string;
    fieldName: string;
    fieldType: 'cardHolderName' | 'expDate' | 'cvc' | 'cardNumber' | 'text';
  };
  isSecureTextEntry?: boolean;
  placeholder?: string;
  textColor?: string;
  fontFamily?: string;
  fontSize?: number;
  style: ViewStyle;
};

export const VGSCollectInput = requireNativeComponent<VGSCollectInputProps>(
  'VgsCollectReactNativeView'
);

export async function registerNamedCollector(
  name: string,
  vaultId: string,
  environment: VGSEnvironment
): Promise<void> {
  await CollectorManager.createNamedCollector(name, vaultId, environment);
}

export async function submit(
  name: string,
  path: string,
  method: 'GET' | 'POST',
  headers: Record<string, string>
): Promise<any> {
  return await CollectorManager.submit(name, path, method, headers);
}
